commit da17a9049ee0a8ca9f93edf137df92e824a7593e
Author: Jason Merrill <jason@redhat.com>
Date:   Thu Mar 23 16:50:09 2023 -0400

    c++: constexpr PMF conversion [PR105996]
    
    Here, we were calling build_reinterpret_cast regardless of whether there was
    actually a cast, and that now sets REINTERPRET_CAST_P.  But that
    optimization seems dodgy anyway, as it involves NOP_EXPR from one
    RECORD_TYPE to another and we try to reserve NOP_EXPR for fundamental types.
    And the generated code seems the same, so let's drop it.  And also strip
    location wrappers.
    
            PR c++/105996
    
    gcc/cp/ChangeLog:
    
            * typeck.c (build_ptrmemfunc): Drop 0-offset optimization
            and location wrappers.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp0x/constexpr-pmf3.C: New test.

diff --git a/gcc/cp/typeck.c b/gcc/cp/typeck.c
index aec933b863b..35bd3c8b056 100644
--- a/gcc/cp/typeck.c
+++ b/gcc/cp/typeck.c
@@ -9036,18 +9036,15 @@ build_ptrmemfunc (tree type, tree pfn, int force, bool c_cast_p,
       if (n == error_mark_node)
 	return error_mark_node;
 
+      STRIP_ANY_LOCATION_WRAPPER (pfn);
+
       /* We don't have to do any conversion to convert a
 	 pointer-to-member to its own type.  But, we don't want to
 	 just return a PTRMEM_CST if there's an explicit cast; that
 	 cast should make the expression an invalid template argument.  */
-      if (TREE_CODE (pfn) != PTRMEM_CST)
-	{
-	  if (same_type_p (to_type, pfn_type))
-	    return pfn;
-	  else if (integer_zerop (n) && TREE_CODE (pfn) != CONSTRUCTOR)
-	    return build_reinterpret_cast (input_location, to_type, pfn, 
-                                           complain);
-	}
+      if (TREE_CODE (pfn) != PTRMEM_CST
+	  && same_type_p (to_type, pfn_type))
+	return pfn;
 
       if (TREE_SIDE_EFFECTS (pfn))
 	pfn = save_expr (pfn);
diff --git a/gcc/testsuite/g++.dg/cpp0x/constexpr-pmf3.C b/gcc/testsuite/g++.dg/cpp0x/constexpr-pmf3.C
new file mode 100644
index 00000000000..14daea312b7
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/constexpr-pmf3.C
@@ -0,0 +1,13 @@
+// PR c++/105996
+// { dg-do compile { target c++11 } }
+
+struct A {
+  void CB() {}
+};
+struct B : public A { };
+
+using APMF = void (A::*)();
+using BPMF = void (B::*)();
+
+constexpr APMF foo () { return &A::CB; };
+static constexpr BPMF b = foo();

